diff --git a/include/infiniband/mad.h b/include/infiniband/mad.h
index b1258bd..88849c8 100644
--- a/include/infiniband/mad.h
+++ b/include/infiniband/mad.h
@@ -755,14 +755,14 @@ enum MAD_FIELDS {
 	 */
 	IB_SA_GIR_LID_F,
 	IB_SA_GIR_BLOCKNUM_F,
-	IB_SA_GIR_GUID0,
-	IB_SA_GIR_GUID1,
-	IB_SA_GIR_GUID2,
-	IB_SA_GIR_GUID3,
-	IB_SA_GIR_GUID4,
-	IB_SA_GIR_GUID5,
-	IB_SA_GIR_GUID6,
-	IB_SA_GIR_GUID7,
+	IB_SA_GIR_GUID0_F,
+	IB_SA_GIR_GUID1_F,
+	IB_SA_GIR_GUID2_F,
+	IB_SA_GIR_GUID3_F,
+	IB_SA_GIR_GUID4_F,
+	IB_SA_GIR_GUID5_F,
+	IB_SA_GIR_GUID6_F,
+	IB_SA_GIR_GUID7_F,
 
 	/*
 	 * More PortInfo fields
@@ -821,206 +821,206 @@ enum MAD_FIELDS {
 	 * PortOpRcvCounters fields
 	 */
 	IB_PC_PORT_OP_RCV_COUNTERS_FIRST_F,
-	IB_PC_PORT_OP_RCV_PKTS = IB_PC_PORT_OP_RCV_COUNTERS_FIRST_F,
-	IB_PC_PORT_OP_RCV_DATA,
+	IB_PC_PORT_OP_RCV_PKTS_F = IB_PC_PORT_OP_RCV_COUNTERS_FIRST_F,
+	IB_PC_PORT_OP_RCV_DATA_F,
 	IB_PC_PORT_OP_RCV_COUNTERS_LAST_F,
 
 	/*
 	 * PortFlowCtlCounters fields
 	 */
 	IB_PC_PORT_FLOW_CTL_COUNTERS_FIRST_F,
-	IB_PC_PORT_XMIT_FLOW_PKTS = IB_PC_PORT_FLOW_CTL_COUNTERS_FIRST_F,
-	IB_PC_PORT_RCV_FLOW_PKTS,
+	IB_PC_PORT_XMIT_FLOW_PKTS_F = IB_PC_PORT_FLOW_CTL_COUNTERS_FIRST_F,
+	IB_PC_PORT_RCV_FLOW_PKTS_F,
 	IB_PC_PORT_FLOW_CTL_COUNTERS_LAST_F,
 
 	/*
 	 * PortVLOpPackets fields
 	 */
 	IB_PC_PORT_VL_OP_PACKETS_FIRST_F,
-	IB_PC_PORT_VL_OP_PACKETS0 = IB_PC_PORT_VL_OP_PACKETS_FIRST_F,
-	IB_PC_PORT_VL_OP_PACKETS1,
-	IB_PC_PORT_VL_OP_PACKETS2,
-	IB_PC_PORT_VL_OP_PACKETS3,
-	IB_PC_PORT_VL_OP_PACKETS4,
-	IB_PC_PORT_VL_OP_PACKETS5,
-	IB_PC_PORT_VL_OP_PACKETS6,
-	IB_PC_PORT_VL_OP_PACKETS7,
-	IB_PC_PORT_VL_OP_PACKETS8,
-	IB_PC_PORT_VL_OP_PACKETS9,
-	IB_PC_PORT_VL_OP_PACKETS10,
-	IB_PC_PORT_VL_OP_PACKETS11,
-	IB_PC_PORT_VL_OP_PACKETS12,
-	IB_PC_PORT_VL_OP_PACKETS13,
-	IB_PC_PORT_VL_OP_PACKETS14,
-	IB_PC_PORT_VL_OP_PACKETS15,
+	IB_PC_PORT_VL_OP_PACKETS0_F = IB_PC_PORT_VL_OP_PACKETS_FIRST_F,
+	IB_PC_PORT_VL_OP_PACKETS1_F,
+	IB_PC_PORT_VL_OP_PACKETS2_F,
+	IB_PC_PORT_VL_OP_PACKETS3_F,
+	IB_PC_PORT_VL_OP_PACKETS4_F,
+	IB_PC_PORT_VL_OP_PACKETS5_F,
+	IB_PC_PORT_VL_OP_PACKETS6_F,
+	IB_PC_PORT_VL_OP_PACKETS7_F,
+	IB_PC_PORT_VL_OP_PACKETS8_F,
+	IB_PC_PORT_VL_OP_PACKETS9_F,
+	IB_PC_PORT_VL_OP_PACKETS10_F,
+	IB_PC_PORT_VL_OP_PACKETS11_F,
+	IB_PC_PORT_VL_OP_PACKETS12_F,
+	IB_PC_PORT_VL_OP_PACKETS13_F,
+	IB_PC_PORT_VL_OP_PACKETS14_F,
+	IB_PC_PORT_VL_OP_PACKETS15_F,
 	IB_PC_PORT_VL_OP_PACKETS_LAST_F,
 
 	/*
 	 * PortVLOpData fields
 	 */
 	IB_PC_PORT_VL_OP_DATA_FIRST_F,
-	IB_PC_PORT_VL_OP_DATA0 = IB_PC_PORT_VL_OP_DATA_FIRST_F,
-	IB_PC_PORT_VL_OP_DATA1,
-	IB_PC_PORT_VL_OP_DATA2,
-	IB_PC_PORT_VL_OP_DATA3,
-	IB_PC_PORT_VL_OP_DATA4,
-	IB_PC_PORT_VL_OP_DATA5,
-	IB_PC_PORT_VL_OP_DATA6,
-	IB_PC_PORT_VL_OP_DATA7,
-	IB_PC_PORT_VL_OP_DATA8,
-	IB_PC_PORT_VL_OP_DATA9,
-	IB_PC_PORT_VL_OP_DATA10,
-	IB_PC_PORT_VL_OP_DATA11,
-	IB_PC_PORT_VL_OP_DATA12,
-	IB_PC_PORT_VL_OP_DATA13,
-	IB_PC_PORT_VL_OP_DATA14,
-	IB_PC_PORT_VL_OP_DATA15,
+	IB_PC_PORT_VL_OP_DATA0_F = IB_PC_PORT_VL_OP_DATA_FIRST_F,
+	IB_PC_PORT_VL_OP_DATA1_F,
+	IB_PC_PORT_VL_OP_DATA2_F,
+	IB_PC_PORT_VL_OP_DATA3_F,
+	IB_PC_PORT_VL_OP_DATA4_F,
+	IB_PC_PORT_VL_OP_DATA5_F,
+	IB_PC_PORT_VL_OP_DATA6_F,
+	IB_PC_PORT_VL_OP_DATA7_F,
+	IB_PC_PORT_VL_OP_DATA8_F,
+	IB_PC_PORT_VL_OP_DATA9_F,
+	IB_PC_PORT_VL_OP_DATA10_F,
+	IB_PC_PORT_VL_OP_DATA11_F,
+	IB_PC_PORT_VL_OP_DATA12_F,
+	IB_PC_PORT_VL_OP_DATA13_F,
+	IB_PC_PORT_VL_OP_DATA14_F,
+	IB_PC_PORT_VL_OP_DATA15_F,
 	IB_PC_PORT_VL_OP_DATA_LAST_F,
 
 	/*
 	 * PortVLXmitFlowCtlUpdateErrors fields
 	 */
 	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS_FIRST_F,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS0 = IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS_FIRST_F,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS1,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS2,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS3,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS4,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS5,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS6,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS7,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS8,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS9,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS10,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS11,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS12,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS13,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS14,
-	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS15,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS0_F = IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS_FIRST_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS1_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS2_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS3_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS4_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS5_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS6_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS7_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS8_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS9_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS10_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS11_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS12_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS13_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS14_F,
+	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS15_F,
 	IB_PC_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS_LAST_F,
 
 	/*
 	 * PortVLXmitWaitCounters fields
 	 */
 	IB_PC_PORT_VL_XMIT_WAIT_COUNTERS_FIRST_F,
-	IB_PC_PORT_VL_XMIT_WAIT0 = IB_PC_PORT_VL_XMIT_WAIT_COUNTERS_FIRST_F,
-	IB_PC_PORT_VL_XMIT_WAIT1,
-	IB_PC_PORT_VL_XMIT_WAIT2,
-	IB_PC_PORT_VL_XMIT_WAIT3,
-	IB_PC_PORT_VL_XMIT_WAIT4,
-	IB_PC_PORT_VL_XMIT_WAIT5,
-	IB_PC_PORT_VL_XMIT_WAIT6,
-	IB_PC_PORT_VL_XMIT_WAIT7,
-	IB_PC_PORT_VL_XMIT_WAIT8,
-	IB_PC_PORT_VL_XMIT_WAIT9,
-	IB_PC_PORT_VL_XMIT_WAIT10,
-	IB_PC_PORT_VL_XMIT_WAIT11,
-	IB_PC_PORT_VL_XMIT_WAIT12,
-	IB_PC_PORT_VL_XMIT_WAIT13,
-	IB_PC_PORT_VL_XMIT_WAIT14,
-	IB_PC_PORT_VL_XMIT_WAIT15,
+	IB_PC_PORT_VL_XMIT_WAIT0_F = IB_PC_PORT_VL_XMIT_WAIT_COUNTERS_FIRST_F,
+	IB_PC_PORT_VL_XMIT_WAIT1_F,
+	IB_PC_PORT_VL_XMIT_WAIT2_F,
+	IB_PC_PORT_VL_XMIT_WAIT3_F,
+	IB_PC_PORT_VL_XMIT_WAIT4_F,
+	IB_PC_PORT_VL_XMIT_WAIT5_F,
+	IB_PC_PORT_VL_XMIT_WAIT6_F,
+	IB_PC_PORT_VL_XMIT_WAIT7_F,
+	IB_PC_PORT_VL_XMIT_WAIT8_F,
+	IB_PC_PORT_VL_XMIT_WAIT9_F,
+	IB_PC_PORT_VL_XMIT_WAIT10_F,
+	IB_PC_PORT_VL_XMIT_WAIT11_F,
+	IB_PC_PORT_VL_XMIT_WAIT12_F,
+	IB_PC_PORT_VL_XMIT_WAIT13_F,
+	IB_PC_PORT_VL_XMIT_WAIT14_F,
+	IB_PC_PORT_VL_XMIT_WAIT15_F,
 	IB_PC_PORT_VL_XMIT_WAIT_COUNTERS_LAST_F,
 
 	/*
 	 * SwPortVLCongestion fields
 	 */
 	IB_PC_SW_PORT_VL_CONGESTION_FIRST_F,
-	IB_PC_SW_PORT_VL_CONGESTION0 = IB_PC_SW_PORT_VL_CONGESTION_FIRST_F,
-	IB_PC_SW_PORT_VL_CONGESTION1,
-	IB_PC_SW_PORT_VL_CONGESTION2,
-	IB_PC_SW_PORT_VL_CONGESTION3,
-	IB_PC_SW_PORT_VL_CONGESTION4,
-	IB_PC_SW_PORT_VL_CONGESTION5,
-	IB_PC_SW_PORT_VL_CONGESTION6,
-	IB_PC_SW_PORT_VL_CONGESTION7,
-	IB_PC_SW_PORT_VL_CONGESTION8,
-	IB_PC_SW_PORT_VL_CONGESTION9,
-	IB_PC_SW_PORT_VL_CONGESTION10,
-	IB_PC_SW_PORT_VL_CONGESTION11,
-	IB_PC_SW_PORT_VL_CONGESTION12,
-	IB_PC_SW_PORT_VL_CONGESTION13,
-	IB_PC_SW_PORT_VL_CONGESTION14,
-	IB_PC_SW_PORT_VL_CONGESTION15,
+	IB_PC_SW_PORT_VL_CONGESTION0_F = IB_PC_SW_PORT_VL_CONGESTION_FIRST_F,
+	IB_PC_SW_PORT_VL_CONGESTION1_F,
+	IB_PC_SW_PORT_VL_CONGESTION2_F,
+	IB_PC_SW_PORT_VL_CONGESTION3_F,
+	IB_PC_SW_PORT_VL_CONGESTION4_F,
+	IB_PC_SW_PORT_VL_CONGESTION5_F,
+	IB_PC_SW_PORT_VL_CONGESTION6_F,
+	IB_PC_SW_PORT_VL_CONGESTION7_F,
+	IB_PC_SW_PORT_VL_CONGESTION8_F,
+	IB_PC_SW_PORT_VL_CONGESTION9_F,
+	IB_PC_SW_PORT_VL_CONGESTION10_F,
+	IB_PC_SW_PORT_VL_CONGESTION11_F,
+	IB_PC_SW_PORT_VL_CONGESTION12_F,
+	IB_PC_SW_PORT_VL_CONGESTION13_F,
+	IB_PC_SW_PORT_VL_CONGESTION14_F,
+	IB_PC_SW_PORT_VL_CONGESTION15_F,
 	IB_PC_SW_PORT_VL_CONGESTION_LAST_F,
 
 	/*
 	 * PortRcvConCtrl fields
 	 */
 	IB_PC_RCV_CON_CTRL_FIRST_F,
-	IB_PC_RCV_CON_CTRL_PKT_RCV_FECN = IB_PC_RCV_CON_CTRL_FIRST_F,
-	IB_PC_RCV_CON_CTRL_PKT_RCV_BECN,
+	IB_PC_RCV_CON_CTRL_PKT_RCV_FECN_F = IB_PC_RCV_CON_CTRL_FIRST_F,
+	IB_PC_RCV_CON_CTRL_PKT_RCV_BECN_F,
 	IB_PC_RCV_CON_CTRL_LAST_F,
 
 	/*
 	 * PortSLRcvFECN fields
 	 */
 	IB_PC_SL_RCV_FECN_FIRST_F,
-	IB_PC_SL_RCV_FECN0 = IB_PC_SL_RCV_FECN_FIRST_F,
-	IB_PC_SL_RCV_FECN1,
-	IB_PC_SL_RCV_FECN2,
-	IB_PC_SL_RCV_FECN3,
-	IB_PC_SL_RCV_FECN4,
-	IB_PC_SL_RCV_FECN5,
-	IB_PC_SL_RCV_FECN6,
-	IB_PC_SL_RCV_FECN7,
-	IB_PC_SL_RCV_FECN8,
-	IB_PC_SL_RCV_FECN9,
-	IB_PC_SL_RCV_FECN10,
-	IB_PC_SL_RCV_FECN11,
-	IB_PC_SL_RCV_FECN12,
-	IB_PC_SL_RCV_FECN13,
-	IB_PC_SL_RCV_FECN14,
-	IB_PC_SL_RCV_FECN15,
+	IB_PC_SL_RCV_FECN0_F = IB_PC_SL_RCV_FECN_FIRST_F,
+	IB_PC_SL_RCV_FECN1_F,
+	IB_PC_SL_RCV_FECN2_F,
+	IB_PC_SL_RCV_FECN3_F,
+	IB_PC_SL_RCV_FECN4_F,
+	IB_PC_SL_RCV_FECN5_F,
+	IB_PC_SL_RCV_FECN6_F,
+	IB_PC_SL_RCV_FECN7_F,
+	IB_PC_SL_RCV_FECN8_F,
+	IB_PC_SL_RCV_FECN9_F,
+	IB_PC_SL_RCV_FECN10_F,
+	IB_PC_SL_RCV_FECN11_F,
+	IB_PC_SL_RCV_FECN12_F,
+	IB_PC_SL_RCV_FECN13_F,
+	IB_PC_SL_RCV_FECN14_F,
+	IB_PC_SL_RCV_FECN15_F,
 	IB_PC_SL_RCV_FECN_LAST_F,
 
 	/*
 	 * PortSLRcvBECN fields
 	 */
 	IB_PC_SL_RCV_BECN_FIRST_F,
-	IB_PC_SL_RCV_BECN0 = IB_PC_SL_RCV_BECN_FIRST_F,
-	IB_PC_SL_RCV_BECN1,
-	IB_PC_SL_RCV_BECN2,
-	IB_PC_SL_RCV_BECN3,
-	IB_PC_SL_RCV_BECN4,
-	IB_PC_SL_RCV_BECN5,
-	IB_PC_SL_RCV_BECN6,
-	IB_PC_SL_RCV_BECN7,
-	IB_PC_SL_RCV_BECN8,
-	IB_PC_SL_RCV_BECN9,
-	IB_PC_SL_RCV_BECN10,
-	IB_PC_SL_RCV_BECN11,
-	IB_PC_SL_RCV_BECN12,
-	IB_PC_SL_RCV_BECN13,
-	IB_PC_SL_RCV_BECN14,
-	IB_PC_SL_RCV_BECN15,
+	IB_PC_SL_RCV_BECN0_F = IB_PC_SL_RCV_BECN_FIRST_F,
+	IB_PC_SL_RCV_BECN1_F,
+	IB_PC_SL_RCV_BECN2_F,
+	IB_PC_SL_RCV_BECN3_F,
+	IB_PC_SL_RCV_BECN4_F,
+	IB_PC_SL_RCV_BECN5_F,
+	IB_PC_SL_RCV_BECN6_F,
+	IB_PC_SL_RCV_BECN7_F,
+	IB_PC_SL_RCV_BECN8_F,
+	IB_PC_SL_RCV_BECN9_F,
+	IB_PC_SL_RCV_BECN10_F,
+	IB_PC_SL_RCV_BECN11_F,
+	IB_PC_SL_RCV_BECN12_F,
+	IB_PC_SL_RCV_BECN13_F,
+	IB_PC_SL_RCV_BECN14_F,
+	IB_PC_SL_RCV_BECN15_F,
 	IB_PC_SL_RCV_BECN_LAST_F,
 
 	/*
 	 * PortXmitConCtrl fields
 	 */
 	IB_PC_XMIT_CON_CTRL_FIRST_F,
-	IB_PC_XMIT_CON_CTRL_TIME_CONG = IB_PC_XMIT_CON_CTRL_FIRST_F,
+	IB_PC_XMIT_CON_CTRL_TIME_CONG_F = IB_PC_XMIT_CON_CTRL_FIRST_F,
 	IB_PC_XMIT_CON_CTRL_LAST_F,
 
 	/*
 	 * PortVLXmitTimeCong fields
 	 */
 	IB_PC_VL_XMIT_TIME_CONG_FIRST_F,
-	IB_PC_VL_XMIT_TIME_CONG0 = IB_PC_VL_XMIT_TIME_CONG_FIRST_F,
-	IB_PC_VL_XMIT_TIME_CONG1,
-	IB_PC_VL_XMIT_TIME_CONG2,
-	IB_PC_VL_XMIT_TIME_CONG3,
-	IB_PC_VL_XMIT_TIME_CONG4,
-	IB_PC_VL_XMIT_TIME_CONG5,
-	IB_PC_VL_XMIT_TIME_CONG6,
-	IB_PC_VL_XMIT_TIME_CONG7,
-	IB_PC_VL_XMIT_TIME_CONG8,
-	IB_PC_VL_XMIT_TIME_CONG9,
-	IB_PC_VL_XMIT_TIME_CONG10,
-	IB_PC_VL_XMIT_TIME_CONG11,
-	IB_PC_VL_XMIT_TIME_CONG12,
-	IB_PC_VL_XMIT_TIME_CONG13,
-	IB_PC_VL_XMIT_TIME_CONG14,
+	IB_PC_VL_XMIT_TIME_CONG0_F = IB_PC_VL_XMIT_TIME_CONG_FIRST_F,
+	IB_PC_VL_XMIT_TIME_CONG1_F,
+	IB_PC_VL_XMIT_TIME_CONG2_F,
+	IB_PC_VL_XMIT_TIME_CONG3_F,
+	IB_PC_VL_XMIT_TIME_CONG4_F,
+	IB_PC_VL_XMIT_TIME_CONG5_F,
+	IB_PC_VL_XMIT_TIME_CONG6_F,
+	IB_PC_VL_XMIT_TIME_CONG7_F,
+	IB_PC_VL_XMIT_TIME_CONG8_F,
+	IB_PC_VL_XMIT_TIME_CONG9_F,
+	IB_PC_VL_XMIT_TIME_CONG10_F,
+	IB_PC_VL_XMIT_TIME_CONG11_F,
+	IB_PC_VL_XMIT_TIME_CONG12_F,
+	IB_PC_VL_XMIT_TIME_CONG13_F,
+	IB_PC_VL_XMIT_TIME_CONG14_F,
 	IB_PC_VL_XMIT_TIME_CONG_LAST_F,
 
 	IB_FIELD_LAST_		/* must be last */